io_uring_prep_send(3)

NAME
io_uring_prep_send - prepare a send request

SYNOPSIS
#include <liburing.h>

void io_uring_prep_send(struct io_uring_sqe *sqe,
                        int sockfd,
                        const void *buf,
                        size_t len,
                        int flags);

void io_uring_prep_sendto(struct io_uring_sqe *sqe,
                          int sockfd,
                          const void *buf,
                          size_t len,
                          int flags,
                          const struct sockaddr *addr,
                          socklen_t addrlen);

DESCRIPTION

The io_uring_prep_send(3) function prepares a send request. The submission queue entry sqe is setup to use the file descriptor sockfd to start sending the data from buf of size len bytes and with modifier flags flags. Note that using IOSQE_IO_LINK with this request type requires the setting of MSG_WAITALL in the flags argument, as a short send isn't a considered an error condition without that being set. This function prepares an async send(2) request. See that man page for details. The io_uring_prep_sendto(3) function prepares a sendto request. The submission queue entry sqe is setup to use the file descriptor sockfd to start sending the data from buf of size len bytes and with modifier flags flags. The destination address is specified by addr and addrlen and must be a valid address for the socket type. This function prepares an async sendto(2) request. See that man page for details.

RETURN VALUE
None

ERRORS
The CQE res field will contain the result of the operation. See the related man page for details on possible values. Note that where synchronous system calls will return -1 on failure and set errno to the actual error value, io_uring never uses errno. Instead it returns the negated errno directly in the CQE res field.

SEE ALSO
io_uring_get_sqe(3), io_uring_submit(3), send(2) sendto(2)